import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Enumeration;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
  *
  * Beschreibung:
  *
  * @version 1.0 vom 01.02.2006
  * @author
  */

public class Gui extends JFrame {
    // Anfang Variablen
    
    private static Gui gui;
    private static Moeblierung moeblierung;
    private Zeichenflaeche zeichenflaeche;
    
    private JLabel labelXPosition;
    private JLabel labelYPosition;
    private JLabel labelFarbe;
    private JLabel labelRichtung;
    private JLabel labelBreite;
    private JLabel labelTiefe;
    
    private JTextField editXPosition;
    private JTextField editYPosition;
    private JTextField editFarbe;
    private JTextField editRichtung;
    private JTextField editBreite;
    private JTextField editTiefe;
    
    private JButton uebernehmenButton;
  
    private JPanel jButtonGroup1Panel;
    private ButtonGroup jButtonGroup1;
    private JRadioButton jButtonGroup1ButtonStuhl;
    private JRadioButton jButtonGroup1ButtonTisch;
    private JRadioButton jButtonGroup1ButtonSchrank;
    private JRadioButton jButtonGroup1ButtonBett;

    // Ende Variablen

    /**
     * Konstruktor
     */
    private Gui(String title, int breite, int hoehe) {
        // Frame-Initialisierung
        super(title);
        setJMenuBar(machMenueLeiste());
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt){ beendenAction(); }
        });
        
        jButtonGroup1Panel=machButtonGruppe();
        
        // Attribute
        setSize(breite, hoehe);
        setLocation(20, 20);
        Container contentPane = getContentPane();
        contentPane.setLayout(null);
    
        // Anfang Komponenten
        labelXPosition = new JLabel("x-Position");
        labelXPosition.setBounds(10, 10, 70, 20);
        contentPane.add(labelXPosition);
        labelYPosition = new JLabel("y-Position");
        labelYPosition.setBounds(10, 40, 70, 20);
        contentPane.add(labelYPosition);
        labelFarbe = new JLabel("Farbe");
        labelFarbe.setBounds(10, 70, 70, 20);
        contentPane.add(labelFarbe);
        labelRichtung = new JLabel("Richtung");
        labelRichtung.setBounds(10, 100, 70, 20);
        contentPane.add(labelRichtung);
        labelBreite = new JLabel("Breite");
        labelBreite.setBounds(10, 130, 70, 20);
        contentPane.add(labelBreite);
        labelTiefe = new JLabel("Tiefe");
        labelTiefe.setBounds(10, 160, 70, 20);
        contentPane.add(labelTiefe);

        
        // Textfelder
        editXPosition = new JTextField("20");
        editXPosition.setBounds(90, 10, 80, 20);
        contentPane.add(editXPosition);
        editYPosition = new JTextField("20");
        editYPosition.setBounds(90, 40, 80, 20);
        contentPane.add(editYPosition);
        editFarbe = new JTextField("rot");
        editFarbe.setBounds(90, 70, 80, 20);
        contentPane.add(editFarbe);
        editRichtung = new JTextField("0");
        editRichtung.setBounds(90, 100, 80, 20);
        contentPane.add(editRichtung);
        editBreite = new JTextField("60");
        editBreite.setBounds(90, 130, 80, 20);
        contentPane.add(editBreite);
        editTiefe = new JTextField("37");
        editTiefe.setBounds(90, 160, 80, 20);
        contentPane.add(editTiefe);
        
        // Buttons
        uebernehmenButton = new JButton ("bernehmen");
        uebernehmenButton.setBounds(10, 200, 160, 20);
        contentPane.add(uebernehmenButton);
        contentPane.add(jButtonGroup1Panel);
        
        // Zeichenflaeche (JPanel)
        zeichenflaeche = new Zeichenflaeche(breite-200, hoehe-100);
        JScrollPane scroll = new JScrollPane(zeichenflaeche);
        scroll.setBounds(180, 10, breite-200, hoehe-100);
        contentPane.add(scroll);
    
        // Ende Komponenten
    
        setResizable(false);
        setVisible(true);
        zeichenflaeche.repaint();
    
        // Anfang Ereignisprozeduren
        uebernehmenButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });
        // Ende Ereignisprozeduren
    }


    /**
     * Definition der Menleiste
     */
    private JMenuBar machMenueLeiste() {
        // enthaltene Objekte definieren
        JMenuBar menueLeiste = new JMenuBar();

        JMenu menueDatei = new JMenu("Datei");
        JMenuItem menueEintragOeffnen = new JMenuItem();
        JMenuItem menueEintragSpeichern = new JMenuItem("Speichern");
        JMenuItem menueEintragEnde = new JMenuItem("Ende");

        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        JMenuItem menueEintragMoebelHinzufuegen = new JMenuItem("Moebel hinzufgen");
        JMenuItem menueEintragMoebelEntfernen = new JMenuItem("Moebel entfernen");
        JMenuItem menueEintragWaehle = new JMenuItem("whle aus");
        JMenuItem menueEintragWaehleNicht = new JMenuItem("lsche Auswahl");

        // Listener definieren
        menueEintragOeffnen.setAction(new AbstractAction("ffnen") {
            public void actionPerformed(ActionEvent e) {
                holenAktion();
           }
        });

        menueEintragSpeichern.addActionListener(new AbstractAction("Speichern") {
            public void actionPerformed(ActionEvent e) {
                sichernAktion();
            }
        });

        menueEintragEnde.addActionListener(new AbstractAction("Ende") {
            public void actionPerformed(ActionEvent e) { beendenAction(); }
        });

        menueEintragMoebelHinzufuegen.addActionListener(new AbstractAction("Mbel hinzufgen") {
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });

        menueEintragMoebelEntfernen.addActionListener(new AbstractAction("Mbel entfernen") {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Mbel entfernen - nicht implementiert");
            }
        });

        menueEintragWaehle.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                moeblierung.waehleAus();
                update();
            }
        });

        menueEintragWaehleNicht.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                moeblierung.loescheAuswahl();
                update();
            }
        });


        // hinzufgen
        menueDatei.add(menueEintragOeffnen);
        menueDatei.add(menueEintragSpeichern);
        menueDatei.add(menueEintragEnde);

        menueBearbeiten.add(menueEintragMoebelHinzufuegen);
        menueBearbeiten.add(menueEintragMoebelEntfernen);
        menueBearbeiten.add(menueEintragWaehle);
        menueBearbeiten.add(menueEintragWaehleNicht);

        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);

        return menueLeiste;
    }
    // Ende der Definitionsmethode fr die Menleiste
    
    // Definition der Radiobutton - Gruppe
    private JPanel machButtonGruppe(){
        jButtonGroup1Panel = new JPanel();
        jButtonGroup1 = new ButtonGroup();
        jButtonGroup1Panel.setBounds(24, 240, 140 , 137);
        jButtonGroup1Panel.setLayout(new GridLayout(4, 1));
        jButtonGroup1ButtonStuhl = machJRadioButton("Stuhl");
        jButtonGroup1.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1Panel.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1ButtonTisch = machJRadioButton("Tisch");
        jButtonGroup1.add(jButtonGroup1ButtonTisch);
        jButtonGroup1Panel.add(jButtonGroup1ButtonTisch);
        jButtonGroup1ButtonSchrank = machJRadioButton("Schrank");
        jButtonGroup1.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1Panel.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1ButtonBett = machJRadioButton("Bett");
        jButtonGroup1.add(jButtonGroup1ButtonBett);
        jButtonGroup1Panel.add(jButtonGroup1ButtonBett);
        jButtonGroup1ButtonSchrank.setSelected(true);
        return jButtonGroup1Panel;
    }
    
    private JRadioButton machJRadioButton(String command){
        JRadioButton jRadioButton = new JRadioButton(command);
        jRadioButton.setActionCommand(command);
        return jRadioButton;
    }
    // Ende der Definitionsmethode fr die Radiobutton - Gruppe
    
    // Commands
    private void uebernehmenAktion(){
        if (!moeblierung.neuesMoebel(
                jButtonGroup1.getSelection().getActionCommand(),
                editXPosition.getText(),
                editYPosition.getText(),
                editFarbe.getText(),
                editRichtung.getText(),
                editBreite.getText(),
                editTiefe.getText()))
        JOptionPane.showMessageDialog(this, "Fehler bei den Daten");
        else update();
    }
    
    private void sichernAktion(){
        try{
            moeblierung.sichern();
        } catch (IOException ioe){ System.out.println("! Ein-Ausgabefehler !");
        }
        update();
    }
    
    private void holenAktion(){
        try{
            moeblierung.holen();
        } catch (ClassNotFoundException cnfe){ System.out.println("! Klasse nicht gefunden !");
        } catch (IOException ioe){ System.out.println("! Ein-Ausgabefehler !");
        }
        update();
    }
    
    private void beendenAction(){ 
        int option= JOptionPane.showConfirmDialog(this, "Zustand speichern ?", "Anwendung beenden" , JOptionPane.YES_NO_CANCEL_OPTION);
        if (option==JOptionPane.YES_OPTION) sichernAktion();
        else if (option==JOptionPane.NO_OPTION) System.exit(0);
    }
    
    private void update(){
        zeichenflaeche.setList(moeblierung.gibZeichnung());
        zeichenflaeche.repaint();
    }
        
    public static void main(String[] args) {
        moeblierung = new Moeblierung();
        gui = new Gui("Gui", 600, 600);
    }
}

