import java.util.Iterator;
import java.util.ArrayList;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.EOFException;


/**
  *
  * Moeblierung - Klasse fr das Moebelprojekt.
  *
  * @author claus albowski
  * @version aug 06
  */
public class Moeblierung
{
    private ArrayList moebelListe;
    private int ausgewaehlt;

    /**
     * Konstruktor fr Objekte der Klasse Moeblierung
     */
    public Moeblierung()
    {
        moebelListe = new ArrayList();
        ausgewaehlt=-1;
    }

    /**
     * sichern
     */
    public void sichern()
    throws IOException{
        try{
            ObjectOutputStream ausgabe= new ObjectOutputStream( new FileOutputStream("moebel.moeb"));
            for (Iterator it= moebelListe.iterator();it.hasNext();){
                ausgabe.writeObject(it.next());
            }
            ausgabe.close();
        } catch (FileNotFoundException e){ System.out.println("Datei existiert nicht!"); };
    }
    
    /**
     * holen
     */
    public void holen()
    throws ClassNotFoundException, IOException{
        try{
            Object o=null;
            moebelListe.clear();
            ObjectInputStream eingabe= new ObjectInputStream( new FileInputStream("moebel.moeb"));
            boolean fertig = false;
            while (!fertig){
                try{
                    o = eingabe.readObject();
                } catch (EOFException eofe) {fertig=true;};
                if (fertig) 
                eingabe.close();
                else moebelListe.add(o);
            }
        } catch (FileNotFoundException e){ System.out.println("Datei existiert nicht!"); };
    }
    
    /**
     * nimmt ein neues Moebel.
     */
    public boolean neuesMoebel(String moebelArt, 
                            String initX,
                            String initY,
                            String initFarbe,
                            String initRichtung,
                            String initBreite,
                            String initHoehe ){
        Moebel moebel=null;
        int x=verwandleInInt(initX);
        int y=verwandleInInt(initY);
        if (moebelArt=="Stuhl") moebel=new Stuhl(x, y, "rot");
        else if (moebelArt=="Tisch") moebel=new Tisch(x, y, "blau");
        else if (moebelArt=="Schrank") moebel=new Schrank(x, y, "gruen");
        else if (moebelArt=="Bett") moebel=new Bett(x, y, "magenta");
        if (moebel!=null) {
            moebelListe.add(moebel);
            return true;
        }
        else return false;
    }
    
    /**
     * entfernt ein Moebel aus der Darstellung.
     * gibt null zurck, wenn es nicht enthalten war.
     */
    public boolean entferneMoebel(Moebel k){
        return moebelListe.remove(k);
    }
    
    /**
     * gibt die zu zeichnenden Moebel als Liste zurck.
     */
    public ArrayList<FarbigesShape> gibZeichnung(){
        ArrayList<FarbigesShape> grafikelemente=new ArrayList<FarbigesShape>();
        for (Iterator it=moebelListe.iterator();it.hasNext();){
            Moebel moebel=(Moebel)it.next();
            if (moebelListe.indexOf(moebel)==ausgewaehlt)
            grafikelemente.add(new FarbigesShape(
                                   moebel.gibAktuelleFigur(),
                                   "lightGray",
                                   false));
            else grafikelemente.add(new FarbigesShape(
                                   moebel.gibAktuelleFigur(),
                                   moebel.gibFarbe(),
                                   false));
        }
        return grafikelemente;
    }
    
    /**
     * verwandleInInt
     * Hilfsmethode
     * wandelt den String -wenn mglich- in eine positive int - Zahl um.
     */
    private int verwandleInInt(String s)
      throws NumberFormatException {
        return Integer.parseInt(s, 10);
    }
    // Methoden, um das Auswaehlen zu steuern
    public void waehleAus(){ ausgewaehlt++; if (ausgewaehlt>=moebelListe.size()) ausgewaehlt=0; }
    public void loescheAuswahl() { ausgewaehlt=-1; }
}
